<%@page import="imagemed.http.IMRequest"%>
<%@page import="imagemed.imtables.WorklistTableParams"%>
<%@page import="java.util.GregorianCalendar"%>
<%@page import="imagemed.types.date.IMTypeDA_TM"%>
<%@page import="imagemed.util.IMMessage"%>
<%@page import="java.text.Format"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="imagemed.util.LocalizedMessage"%>
<%@page import="imagemed.imtables.queryqualifier.QueryQualifier"%>
<%@page import="imagemed.util.IMProperties"%>
<%@page import="java.util.Properties"%>
<%@page import="imagemed.summaries.Summary"%>
<%@page import="imagemed.summaries.SummaryManager"%>
<%@page import="imagemed.lists.GenericUserList"%>
<%@
 page import = "imagemed.util.Helper,imagemed.actions.*,java.io.*,java.sql.*, imagemed.imsession.*,imagemed.types.flag.*,java.nio.file.*"

%><%-- ----- Helper Functions ----- --%><%!

// lock related stuff
static boolean bReentry = false;

synchronized static boolean lock() {
	if ( bReentry )
		return false;
	bReentry = true;
	return true;
}

static void unlock() {
	bReentry = false;
}
// end of lock related stuff

DcAction theActions[] = DcActionManager.getActions();

void checkUser( IMSession is, String userName, String rights, String group, boolean checkSlow ) throws IOException {
	//this will store the userID in the threadLocal session instance
	IMSession.getSession().setRegID( userName );
	// To warkaround null pointer exceptions when calling a parent/child server and passing user data
	// TODO: move it to the session handling
	IMSession.getSession().regRights = rights;
	IMSession.getSession().regGroup = group;
	
	String filterDataDirName = IMEnvBase.getEnv( "USERS_DATA" ) + "/" + userName + "/filters";
	if ( filterDataDirName != null ) {
		try (DirectoryStream<Path> ds = Helper.getDirectoryStream( filterDataDirName )) {
			if(ds == null){
				// filter directory does not exist
				return;
			}
			for ( Path p : ds ) {
				String fileName = (p.toAbsolutePath()).toString();
//				is.out.println( "--- processing file: " + fileName + "<BR>" );
				for ( int n = 0; n != theActions.length; n++ ) {
					
					//if group, only check Notify
					if ( userName.startsWith( "#" ) && !"Notify".equals( theActions[ n ].getName() ) ) {
						continue;
					}
					DcAction act = theActions[ n ];
					if ( !"".equals( act.getReqRights() ) && rights.indexOf( act.getReqRights() ) == -1 ) {
						continue;
					}
					String listid = act.isActionFile( fileName );
					if ( listid == null ) {
						continue;
					}
					
					is.out.println( "<B>" + act.getName() + "</B><BR>" );
					// listname.ip.ip.ip.ip.xxx

					act.setList( userName, listid );

					if( rights.indexOf( IMTypeur.RESTRICTED_QUERY_RIGHT ) == -1 ) {
						//re-check slow query
						if( checkSlow ) {
							String mesName = "slowAction-" + userName + "-" + listid + "-"+ act.getName();
							//message must be deleted, when the query is not slow!
							// because message doesn't do any deleting
							try {
								IMProperties props = new IMProperties();
								props.recRead( act.getListFileName() );
						    	QueryQualifier qq = new QueryQualifier();
						    	String qualif = qq.qualifyFilters( new WorklistTableParams( act.getUserID() ,act.getListName(), false, true ), true, true );
						    	if( !QueryQualifier.GOOD.equals( qualif ) ) {
						    		String problem = LocalizedMessage.getCompoundMessage( "QQ_BAD_QUERY_ACTION_RUNNING", new Format[]{ null, null, null }, new Object[]{ userName, listid, act.getName() }, false );
						    		is.out.print( problem + "<BR>\n" );
									List<String> mes = new ArrayList<String>();
									mes.add( "<center>" + problem + "</center>" );
									IMMessage.createMessageByRight( mesName, mes, IMTypeur.ADMIN_RIGHT, 10000000, 1440, false );
						    	}
						    	else {
						    		IMMessage.delete( mesName );
						    	}
							}
							catch( Throwable th ) {
								Helper.defaultCatch( th );
							}
						}
					}

					is.out.print( "checking " + userName + "'s " + listid + "<BR>\n" );
					UserList.acquireListLock( userName, listid );
					try {
						act.checkAction( is );
					}
					catch ( Exception e ) {
						try {
							Helper.ERRORLOG( "action.jsp", "Checking/executing actions on " + userName+ "'s " + listid + " list failed: " + e.getMessage() );
							Helper.ERRORLOG( "action.jsp", Helper.throwable2String( e ) );
							is.out.println( "<PRE>" );
							is.out.println( Helper.htmlEncode( Helper.throwable2String( e ) ) );
							is.out.println( "</PRE>" );
						}
						catch ( Exception ex ) {
						}
					}
					finally {
						UserList.releaseListLock( userName, listid );
					}
				} // for all actions
			} // for all files in user filter directory
		}
		
		// check summaries
		for( int i = 0; i < GenericUserList.LIST_SUBDIRS.length; i++ ) {
			String[] filterNames = UserList.getFilterNames( userName, i );
			Summary[] sums = SummaryManager.getSummaries( i );
			for( int j = 0; j < filterNames.length; j++ ) {
				UserList.acquireListLock( userName, i, filterNames[ j ] );
				try {
					for( int k = 0; k < sums.length; k++ ) {
						sums[ k ].checkAndRun( is, userName, i, filterNames[ j ] );
					}
				}
				catch( Exception e ) {
					Helper.defaultCatch( e );
				}
				finally {
					UserList.releaseListLock( userName, i, filterNames[ j ] );
				}
			}
		}
	} // if filterdir exists
}

%><%
	if ( !lock() ) {
		out.println( "cannot reenter" );
		return;
	}
	try {
		IMSession is = new IMSession( request, response, out ); 
		is.createIMRequest( false );
		
		is.sessionVariables.setProperty("actionJsp", "true");

		boolean checkSlow = false;
		GregorianCalendar now = new GregorianCalendar();
		String actDate = Helper.calcDayStr( now );
		try {
			String envq = "select * from Env";
			ResultSet rs = IMEnv.getDB().createStatement().executeQuery( envq );
			if( rs.next( ) ) {
				String lastDate = rs.getString( "SLOWQUERYCHECK" );
				if( !actDate.equals( lastDate ) ) {
					checkSlow = true;
				}	
			}
		}
		catch( Throwable th ) {
			Helper.defaultCatch( th );
		}
		
		PreparedStatement psUsers = IMEnv.getDB().prepareStatement( "select USERID,USERNAME,RIGHTS,AGROUP from " + IMEnvBase.getEnv( "ACCESSTBL" ) );
		ResultSet rsUsers = psUsers.executeQuery();
		while ( rsUsers.next() ) {
			String userName = rsUsers.getString( "USERID" );
			String group = rsUsers.getString( "AGROUP" );
			String rights = IMTypeur.applyForcedRights( rsUsers.getString( "RIGHTS" ), rsUsers.getString( "AGROUP" ) );
			checkUser( is, userName, rights, group, checkSlow ); 
		} // for all users
		String userName = "@system";
		String rights = IMTypeur.fullRight();
		checkUser( is, userName, rights, "Admin", checkSlow );
		//check actions for groups ( actually there can be only notify actions for groups )
		String gstmnt = "SELECT ID, GROUPSRIGHTS FROM " + IMEnvBase.getEnv( "GROUPSTBL" );
		ResultSet rsGroups = IMEnv.getDB().prepareStatement( gstmnt ).executeQuery();
		while ( rsGroups.next() ) {
			checkUser( is, "#" + rsGroups.getString( "ID" ), IMTypeur.applyForcedRights( rsGroups.getString( "GROUPSRIGHTS" ), "" ), null, checkSlow );
		}//checking for all groups
		
		if( checkSlow ) {		
			String envu = "update Env set SLOWQUERYCHECK='" + actDate + "'";
			IMEnv.getDB().createStatement().execute( envu );
		}

	}
	finally {
		unlock();
	}
%>