<%--
 * Component: cases
 *
 * Description:
 *  Lists informations on available viewer plugins
 *
 *  OBSOLETE, REMOVED, considered true @param pluginversion	Returns the plugin version from .plv file. practicebuilder>=5.2 should set this to 'true'
 *
--%><%@
	page import="imagemed.util.*,java.io.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.exception.*,java.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );

	if ( !is.regOK() ) {
		return;
	}
	String platform = request.getParameter( "platform" );
	//empty or null defaults to x86, which means root dir	
	
	// like '/x64'
	String platformDir = "";
	// platforDir is relevant only at PluginPath and the .plv file
	
	if ( PluginToolbox.PLATFORM_X64.equals( platform ) ) {
		platformDir = "/" + platform;
	}
	else if ( platform != null && !"".equals( platform ) && !PluginToolbox.PLATFORM_X86.equals( platform ) ) {
		response.setHeader( "ERROR", "Unknown 'platform' parameter:" + platform );
		return;
	}
	
	List<String> plugins = null;
	if ( is.regID != null && is.regID.length() > 0 ) {
		plugins = PluginToolbox.getPluginsFor( is.regID );
	}
	
	String strPluginListData =  "# PluginPath: /download/plugins" + platformDir + "/\r\n\r\n";

	if ( !PluginToolbox.PLUGINSDIR.exists() ) {
		// plugins directory is not linked into data/download directory!!!
		response.setHeader( "ERROR", "\"plugins\" directory does not present in download component. Restarting the download component solves this problem." );
		return;
	}
	
	// if 1 plugin exceeds limits, we don't give it but give the others 
	/*
	try {
		PluginToolbox.checkPluginLimits();
	}
	catch (IMException ime) {
		// plugins directory is not linked into data/download directory!!!
		response.setHeader("ERROR", ime.getMessage());
		return;
	}
	*/
	
	// shortName already consists of language extension!

	for ( String shortName : PluginToolbox.getAllPlugins() ) {
		if ( plugins != null && !plugins.contains( shortName ) ) {
			continue;
		}
		
		if( PluginToolbox.isPluginExceedLimits( shortName, null ) ) {
			continue;
		}
		
		try {
			String fVerName = PluginToolbox.PLUGINSDIR + platformDir + "/" + PluginToolbox.getPluginFileName( platformDir, shortName, ".plv" );
			File fVer = new File( fVerName );
			
			if ( !"".equals( platformDir ) && !fVer.exists() ) {
				// in x64 version if no .plv file exists, we don't give the plugin at all
				continue;
			}
			
			strPluginListData += "# PluginFile: " +	PluginToolbox.getPluginFileName( "", shortName, ".dll" ) + "\r\n";

			FileInputStream inStream;
			char[] buffer = new char[2048];
			int nBytes;
			if ( fVer.exists() ) {
				String plv = Helper.readTextFile( fVerName );
				if ( plv == null ) {
					strPluginListData += "# RealVersion: \n";
				}
				else {
					if ( plv.indexOf( "RealVersion:" ) != -1 ) {
						//new type, send it as is
						strPluginListData += plv;
					}
					else {
						strPluginListData += "# RealVersion: " + plv + "\n";
					}
				}
			}
			else {
				strPluginListData += "# RealVersion: \n";
			}
			File plxFile = new File( PluginToolbox.PLUGINSDIR, PluginToolbox.getPluginFileName( "", shortName, ".plx" ) );
			inStream = new FileInputStream( plxFile );
			InputStreamReader in= new InputStreamReader( inStream, "ISO-8859-1" );

			while ( true ) {
				nBytes = in.read( buffer, 0, 2048 );
				strPluginListData += new String( buffer, 0, nBytes );
				if ( nBytes < 2048 )
					break;
			}

			inStream.close();

		}
		catch( Throwable t1 ) {
			strPluginListData += "# Error reading file";
		}

	}


	response.setContentType( "text/plain" );
	response.setHeader( "Content-length", Long.toString( strPluginListData.length() ) );
	response.setHeader( "Pragma", "no-cache" );

	out.println( strPluginListData );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
