<%--
 * Component: cases
 *
 * Removes specified objects from a study
 *
 * @param cStudy  Study Instance UID of the study
 * @param cFile   File name if the object(s) to be removed
 * @param cUser   User ID to be logged
 *
 * Last Updated by  : $Author$
 * Last Modified    : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="imagemed.util.*, imagemed.imsession.*, imagemed.jsputil.*, java.util.*, imagemed.dcprocessing.StudyRemover, imagemed.taskd.IMScriptContext"

%><%!

	static Syslog logger = new Syslog("removeFiles", 0, IMEnvBase.getEnv("LOG_FACILITY"));

%><%-- Input Parameters --%><%

	IMSession is = new IMSession(request, response, out);

	response.setContentType("text/plain");

	String device = null;
	try {
		Properties remotePrp = DotcomToolbox.checkClient(is, null, false);
		device = remotePrp.getProperty("ID");
	}
	catch (Throwable th) {
	}

	if (device == null) {
		// Unauthorized peer - neither child nor parent
		IfaceToolbox.printError(is, "Unauthorized peer");
		return;
	}
			
	String parStudy = request.getParameter("cStudy");
	String parUser = request.getParameter("cUser");
	String parFiles[] = request.getParameterValues("cFile");

	if (parStudy == null || parFiles == null || parFiles.length == 0) {
		IfaceToolbox.printError(is, "Missing or invalid arguments");
		return;
	}

	IMScriptContext context = IMScriptContext.readJobContextFrom( request );
	
	List<String> files = Arrays.asList(parFiles);

	logger.syslog(Syslog.LOG_DEBUG, "Remove files from  " + parStudy);

	if ( !StudyRemover.removeFiles( context, parStudy, device, parUser, files ) ) {
		IfaceToolbox.printError(is, "Removing the files failed");
		return;
	}

	IfaceToolbox.printOK(is);
%>
