#!/bin/sh
#
# Description:
# OBSOLETE [7.0]
#     Removes specified files from the study on a remote dotcom server.
#
# Synopsis:
#    removeFilesFromPeer.sh -s <study> -H <hostid> [-u <user>] <file>...
#
# Arguments:
#     -s <study>  : Study Instance UID
#     -H <hostid> : ID of the remote dotcom server to remove files on
#     -u <user>   : user Id of the user initiating file removal
#     <file>...   : List of files to be removed
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#


. $HOME/etc/setenv.sh


# if removeFilesFromPeer.sh is called directly:
# run as a task instead
if [ `basename $0` = "removeFilesFromPeer.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi


LOGGER="/usr/bin/logger"
TAG="removeFilesFromPeer[$$]"

study=""
hostid=""
user=""
files=""
PASS_PARAMS=""

while getopts 's:u:H:' OPT; do
	case $OPT in
		s) study="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -s \"$OPTARG\"" ;;
		u) user="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -u \"$OPTARG\"" ;;
		H) hostid="$OPTARG" ; PASS_PARAMS="$PASS_PARAMS -H \"$OPTARG\"" ;;
		*) exit 0 ;;
	esac
done

shift $(( $OPTIND - 1 ))

while [ -n "$1" ] ; do
	PASS_PARAMS="$PASS_PARAMS \"$1\""
	shift
done

# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi

# override getPeer_() of nettask.shi
getPeer_()
{
	echo "$hostid"
}



run_() # override run_ method
{
	[ -z "$study" -o -z "$files" -o -z "$hostid" ] && return 125

	$TASKD_HOME/runjavacmd -c "0 cases.RemoveFilesFromPeer $PASS_PARAMS" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
}


# override print_
print_()
{
	$TASKD_HOME/runjavacmd -c "print cases.RemoveFilesFromPeer $PASS_PARAMS" -p "$JAVA_SERVER_PORT"
}
